#ifndef __CINT__
#include <bloproot.h>
using namespace std;
using namespace blop;
int exa2(int argc, char* argv[]);
int main(int argc, char*argv[]) { return exa2(argc, argv); }
#endif


int exa2(int argc, char* argv[])
{

  // BLOP 2d histograming example:
  hist h2(-10.0, 10.0, 20, "Random variable 1", -10.0, 10.0, 20, "Random variable 2", "Entries", "Gaussian random data");
  function gauss_generator1 = random_gauss(0.0, 3.0);
  const vector<var> dummyvar1;
  function gauss_generator2 = random_gauss(0.0, 4.0);
  const vector<var> dummyvar2;
  for ( int i=0 ; i<1000 ; ++i )
  {
    h2.fill(gauss_generator1.eval_dbl(dummyvar1), gauss_generator2.eval_dbl(dummyvar2));
  }

  // Plot with BLOP facilities:
  set::clear();
  set::title("A 2d histograming example");
  set::xlabel(h2.axistitle(1));
  set::ylabel(h2.axistitle(2));
  set::xrange(h2.min(1), h2.max(1));
  set::yrange(h2.min(2), h2.max(2));
  mplot(h2).drawstyle(csboxes().title(h2.rangetitle())).legend(h2.legend());
  // Print the above stuff to blopeps terminal:
  blopeps::print("exa2.beps");

  // BLOP 2d histograming example:
  TH2D rTH2D("th2d", "Test data;Random variable1;Random variable2;Entries", 10, -5.0, 5.0, 10, -5.0, 5.0);
  for ( int i=0 ; i<10000 ; ++i )
  {
    rTH2D.Fill(gauss_generator1.eval_dbl(dummyvar1), gauss_generator2.eval_dbl(dummyvar2));
  }
  hist bTH2D;
  r2b_convert(rTH2D, bTH2D);
  set::clear();
  set::title("A 2d ROOT to BLOP histograming example");
  set::xlabel(bTH2D.axistitle(1));
  set::ylabel(bTH2D.axistitle(2));
  set::xrange(bTH2D.min(1), bTH2D.max(1));
  set::yrange(bTH2D.min(2), bTH2D.max(2));
  mplot(bTH2D).drawstyle(csboxes().title(bTH2D.rangetitle())).legend(bTH2D.legend());
  blopeps::print("exaroot2.beps");
  bTH2D.write("exaroot2.dat");

  return 0;
}

